package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;

import com.ekexiu.portal.po.Professor;
import com.ekexiu.portal.po.Tidings;

@DAO
public abstract class TidingsDao {
	@Insert
	public abstract int insert(Connection con, Tidings tidings) throws SQLException;
	
	public int updateReadStatus(Connection con,String senderId,String consultId) throws SQLException{
        int _m_1 = 1;
        String sql ="UPDATE TIDINGS SET READ_STATUS = 1 WHERE READ_STATUS = 0 AND CONSULT_ID = ? AND SENDER_ID != ? ";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,consultId);
            ps.setString(_m_1++,senderId);
            return ps.executeUpdate();
        }finally{
            try{ps.close();}catch(Exception _m_2){}
        }
    }
	
	/**
	 * 查询未查看信息条数的接口 
	 * @param con
	 * @param consultId 咨询ID
	 * @param senderId 登录者ID
	 * @return 返回该咨询中对方发送过来未查看的信息条数
	 * @throws SQLException
	 */
	public int queryNotReadTidings(Connection con, String consultId, String senderId) throws SQLException {
		String sql = " SELECT COUNT(1) FROM TIDINGS WHERE READ_STATUS = 0 AND CONSULT_ID = ? AND SENDER_ID != ? ";
		PreparedStatement ps = con.prepareStatement(sql);
		ps.setString(1, consultId);
		ps.setString(2, senderId);
		ResultSet rs = ps.executeQuery();
		rs.next();
		int count = rs.getInt(1);
		return count;
	}
	
	public com.ekexiu.portal.po.Tidings query(java.sql.Connection con,java.lang.String tidingsId) throws java.sql.SQLException{
        int _m_1 = 1;
        String sql = "SELECT TIDINGS_ID,TIDINGS_CONTANT,SENDER_ID,CONSULT_ID,TIDINGS.CREATE_TIME,PROFESSOR.NAME FROM TIDINGS LEFT JOIN PROFESSOR ON SENDER_ID = PROFESSOR.ID WHERE TIDINGS_ID = ?";
        java.sql.PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,tidingsId);
            java.sql.ResultSet rs = ps.executeQuery();
            try{
                if(rs.next()){
                    com.ekexiu.portal.po.Tidings _result = new com.ekexiu.portal.po.Tidings();
                    _result.setTidingsId(rs.getString(1));
                    _result.setTidingsContant(rs.getString(2));
                    Professor professor = new Professor();
                    professor.setId(rs.getString(3));
                    _result.setConsultId(rs.getString(4));
                    _result.setCreateTime(rs.getString(5));
                    professor.setName(rs.getString(6));
                    _result.setProfessor(professor);
                    return _result;
                }else{
                    return null;
                }
            }finally{
                try{rs.close();}catch(Exception _m_2){}
            }
        }finally{
            try{ps.close();}catch(Exception _m_3){}
        }
    }
	
	public java.util.List<com.ekexiu.portal.po.Tidings> queryCon(java.sql.Connection con,java.lang.String consultId) throws java.sql.SQLException{
        int _m_1 = 1;
        String sql = "SELECT TIDINGS_ID,TIDINGS_CONTANT,SENDER_ID,TIDINGS.CONSULT_ID,TIDINGS.CREATE_TIME,PROFESSOR.NAME FROM TIDINGS LEFT JOIN PROFESSOR ON SENDER_ID = PROFESSOR.ID WHERE TIDINGS.CONSULT_ID = ? ORDER BY TIDINGS.CREATE_TIME";
        java.sql.PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,consultId);
            java.sql.ResultSet rs = ps.executeQuery();
            try{
                java.util.List<com.ekexiu.portal.po.Tidings> _result = new java.util.ArrayList<com.ekexiu.portal.po.Tidings>();
                while(rs.next()){
                    com.ekexiu.portal.po.Tidings _obj =  new com.ekexiu.portal.po.Tidings();
                    _obj.setTidingsId(rs.getString(1));
                    _obj.setTidingsContant(rs.getString(2));
                    Professor professor = new Professor();
                    professor.setId(rs.getString(3));
                    _obj.setConsultId(rs.getString(4));
                    _obj.setCreateTime(rs.getString(5));
                    professor.setName(rs.getString(6));
                    _obj.setProfessor(professor);
                    _result.add(_obj);
                }
                return _result;
            }finally{
                try{rs.close();}catch(Exception _m_2){}
            }
        }finally{
            try{ps.close();}catch(Exception _m_3){}
        }
    }
	
}
